//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DongleControllerLib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // Note: this is example code. Return values are checked but may cause memory
  //  and resource leaks.

  SAFEARRAY * pub = SetupDongle1->GenerateKey();

  long len;
  OLECHECK(SafeArrayGetUBound(pub, 1, &len));
  void * ptr;
  OLECHECK(SafeArrayAccessData(pub, &ptr));
  TFileStream * file = new TFileStream("public.key", fmCreate | fmShareExclusive);
  file->Write(ptr, len + 1);
  delete file;
  OLECHECK(SafeArrayUnaccessData(pub));
  OLECHECK(SafeArrayDestroy(pub));

  SAFEARRAY * priv = SetupDongle1->PrivateKey;
  OLECHECK(SafeArrayGetUBound(priv, 1, &len));
  OLECHECK(SafeArrayAccessData(priv, &ptr));
  file = new TFileStream("private.key", fmCreate | fmShareExclusive);
  file->Write(ptr, len + 1);
  delete file;
  OLECHECK(SafeArrayUnaccessData(priv));
  OLECHECK(SafeArrayDestroy(priv));
}
//---------------------------------------------------------------------------
SAFEARRAY * TForm1::read_file(AnsiString name)
{
  TFileStream * file = new TFileStream(name, fmOpenRead);

  SAFEARRAYBOUND sabound[1];
  sabound[0].cElements = (int) file->Size;
  sabound[0].lLbound = 0;
  SAFEARRAY * ret = SafeArrayCreate(VT_UI1, 1, sabound);
  void * ptr;
  SafeArrayAccessData(ret, &ptr);

  int read = 0;
  while (read != file->Size)
    read += file->Read(ptr, file->Size - read);
  delete file;
  SafeArrayUnaccessData(ret);
  return ret;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  SAFEARRAY * tmp = read_file("private.key");
  SetupDongle1->set_PrivateKey(tmp);
  SafeArrayDestroy(tmp);
  SetupDongle1->SignDongle();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  SAFEARRAY * tmp = read_file("public.key");
  if (UseDongle1->VerifyDongle(tmp))
    Application->MessageBox("Validation successful", "Results");
  else
    Application->MessageBox("Validation failed", "Results");
  SafeArrayDestroy(tmp);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  SAFEARRAY * tmp = read_file("private.key");
  SetupDongle1->set_PrivateKey(tmp);
  SafeArrayDestroy(tmp);
  SetupDongle1->SignDonglePassword(WideString(Edit1->Text));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  SAFEARRAY * tmp = read_file("public.key");
  if (UseDongle1->VerifyDonglePassword(tmp, WideString(Edit1->Text)))
    Application->MessageBox("Validation successful", "Results");
  else
    Application->MessageBox("Validation failed", "Results");
}
//---------------------------------------------------------------------------

