unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DongleControllerLib_TLB, OleServer, ActiveX, ComObj;

type
  TForm1 = class(TForm)
    SetupDongle1: TSetupDongle;
    UseDongle1: TUseDongle;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Button4: TButton;
    Button5: TButton;
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function read_file(name: AnsiString): PSafeArray;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  pub, priv: PSafeArray;
  len: Integer;
  ptr: Pointer;
  f: TFileStream;
begin
  // Note: this is example code. Return values are checked but may cause memory
  //  and resource leaks.

  pub := SetupDongle1.GenerateKey();

  OleCheck(SafeArrayGetUBound(pub, 1, @len));
  OleCheck(SafeArrayAccessData(pub, @ptr));
  f := TFileStream.Create('public.key', fmCreate);
  f.Write(ptr, len + 1);
  f.Destroy();
  OleCheck(SafeArrayUnaccessData(pub));
  OleCheck(SafeArrayDestroy(pub));

  priv := SetupDongle1.PrivateKey;
  OleCheck(SafeArrayGetUBound(priv, 1, &len));
  OleCheck(SafeArrayAccessData(priv, &ptr));
  f := TFileStream.Create('private.key', fmCreate);
  f.Write(ptr, len + 1);
  f.Destroy();
  OleCheck(SafeArrayUnaccessData(priv));
  OleCheck(SafeArrayDestroy(priv));

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  tmp: PSafeArray;
begin
  tmp := read_file('private.key');
  SetupDongle1.PrivateKey := tmp;
  SafeArrayDestroy(tmp);
  SetupDongle1.SignDongle();
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  tmp: PSafeArray;
begin
  tmp := read_file('public.key');
  if (UseDongle1.VerifyDongle(tmp)) then
    begin
      Application.MessageBox('Validation successful', 'Results');
    end
  else
    Application.MessageBox('Validation failed', 'Results');
  SafeArrayDestroy(tmp);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  tmp: PSafeArray;
begin
  tmp := read_file('private.key');
  SetupDongle1.PrivateKey := tmp;
  SafeArrayDestroy(tmp);
  SetupDongle1.SignDonglePassword(WideString(Edit1.Text));
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  tmp: PSafeArray;
begin
  tmp := read_file('public.key');
  if (UseDongle1.VerifyDonglePassword(tmp, WideString(Edit1.Text))) then
    begin
      Application.MessageBox('Validation successful', 'Results');
    end
  else
    Application.MessageBox('Validation failed', 'Results');
  SafeArrayDestroy(tmp);
end;

function TForm1.read_file(name: string): PSafeArray;
var
  f: TFileStream;
  sabound: array[0..1] of SAFEARRAYBOUND;
  ret: PSafeArray;
  ptr: Pointer;
  read: Integer;
begin
  f := TFileStream.Create(name, fmOpenRead);

  sabound[0].cElements := f.Size;
  sabound[0].lLbound := 0;
  ret := SafeArrayCreate(VT_UI1, 1, sabound);
  SafeArrayAccessData(ret, &ptr);

  read := 0;
  while (read <> f.Size) do
    read := read + f.Read(ptr, f.Size - read);
  f.Destroy();
  SafeArrayUnaccessData(ret);
  read_file := ret;
end;

end.
