using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using DongleControllerLib;
using System.IO;

namespace Test
{
    public partial class Form1 : Form
    {
	    static byte[] read_file(string name)
	    {
            FileStream file = new FileStream(name, FileMode.Open);
            int len = (int)file.Length;
            byte[] ret = new byte[len];
            int read = 0;
            while (read != len)
                read += file.Read(ret, read, len - read);
            file.Close();
            return ret;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SetupDongleClass setup = new SetupDongleClass();
            byte [] pub = setup.GenerateKey();
            byte [] priv = setup.PrivateKey;

            Stream pub_file = new FileStream("public.key", FileMode.Create);
            pub_file.Write(pub, 0, pub.Length);
            pub_file.Close();

            Stream priv_file = new FileStream("private.key", FileMode.Create);
            priv_file.Write(priv, 0, priv.Length);
            priv_file.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SetupDongleClass sign = new SetupDongleClass();
            sign.PrivateKey = read_file("private.key");
            sign.SignDongle();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            UseDongleClass verify = new UseDongleClass();
            if (verify.VerifyDongle(read_file("public.key")))
                MessageBox.Show("Validation successful");
            else
                MessageBox.Show("Validation failed");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SetupDongleClass sign = new SetupDongleClass();
            sign.PrivateKey = read_file("private.key");
            sign.SignDonglePassword(textBox1.Text);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            UseDongleClass verify = new UseDongleClass();
            if (verify.VerifyDonglePassword(read_file("public.key"), textBox1.Text))
                MessageBox.Show("Validation successful");
            else
                MessageBox.Show("Validation failed");
        }
    }
}