// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <objbase.h>
#include <windows.h>
#include <iostream>

using namespace std;

#include "DongleController.h"
#include "DongleController_i.c"

int main(int argc, char* argv[])
{
	HRESULT hr = CoInitialize(NULL); // Initialize COM library
	SAFEARRAY *pPublicKey;
	SAFEARRAY *pPrivateKey;
	char cAnswer = 0;
	VARIANT_BOOL vb;

	ISetupDongle * ptrISetupDongle;
	IUseDongle * ptrIUseDongle;


	if (FAILED(hr)) { //if initialization fails then exit
		return FALSE;
    }
	//create the com
	hr = CoCreateInstance(CLSID_SetupDongle, NULL, 
		                  CLSCTX_INPROC_SERVER, IID_ISetupDongle,
			              (LPVOID*) &ptrISetupDongle);

	if (FAILED(hr)){
		ptrISetupDongle = NULL;
	}
	hr = CoCreateInstance(CLSID_UseDongle, NULL, 
		                  CLSCTX_INPROC_SERVER, IID_IUseDongle,
			              (LPVOID*) &ptrIUseDongle);
	if (FAILED(hr)){
		ptrIUseDongle = NULL;
	}

	if(ptrISetupDongle) {
		hr = ptrISetupDongle->GenerateKey(&pPublicKey);
		if (FAILED(hr)) {
			cout << "Failed to get public key\n";
			return FALSE;
		}
		else {
			hr = ptrISetupDongle->get_PrivateKey(&pPrivateKey);
			if (FAILED(hr)) {
				cout << "Failed to get private key\n";
				return FALSE;
			}
		}
	}

	cout << "Do you want to sign dongle?[Y/N](N) ";
	cin >> cAnswer;
		
	if(ptrISetupDongle && pPrivateKey && (cAnswer == 'Y' || cAnswer == 'y')) {
		hr = ptrISetupDongle->put_PrivateKey(pPrivateKey);
		if(FAILED(hr)) {
			cout << "Sign set private key failed\n";
			return FALSE;
		}
		else {
			hr = ptrISetupDongle->SignDongle();
			if (FAILED(hr)) {
				cout << "Sign failed\n";
				return FALSE;
			}
		}

		if(ptrIUseDongle) {
			hr = ptrIUseDongle->VerifyDongle(pPublicKey, &vb);
			if (FAILED(hr)) {
				cout << "Verify call failed\n";	
				cin >> cAnswer;
				return FALSE;
			}
			else {
				if(vb == VARIANT_TRUE) {
					cout << "Verify dongle passed\n";
				}
				else {
					cout << "Verify dongle failed\n";
					cin.read(&cAnswer, 1);
				}
			}
		}
	}


	cout << "Do you want to password sign dongle with Logic?[Y/N](N) ";
	cin >> cAnswer;

	if(ptrISetupDongle && (cAnswer == 'Y' || cAnswer == 'y')) {
		BSTR mresult = ::SysAllocString(L"Logic");
		hr = ptrISetupDongle->SignDonglePassword(mresult);
		if (FAILED(hr)) {
			cout << "Sign failed\n";
		}

		if(ptrIUseDongle) {
			hr = ptrIUseDongle->VerifyDonglePassword(pPublicKey, mresult, &vb);
			if (FAILED(hr)) {
				cout << "Verify call failed\n";
				cin.read(&cAnswer, 1);
				return FALSE;
			}
			else {
				if(vb == VARIANT_TRUE) {
					cout << "Verify dongle Password passed\n";
				}
				else {
					cout << "Verify dongle  Password failed\n";
					cin.read(&cAnswer, 1);
					return FALSE;
				}
			}
		}
	}

	if(ptrISetupDongle) {
		ptrISetupDongle->Release();
	}
	if(ptrIUseDongle) {
		ptrIUseDongle->Release();
	}

	cin.read(&cAnswer, 1);
	cin.read(&cAnswer, 1);

	return 0;
}

